// MainFrm.cpp : implementation of the CMainFrame class
// 

#include "stdafx.h"
#include "MedDLe.h"

#include "MainFrm.h"
//#include "CameraView.h"
#include "Anim.h"
#include "Splash.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_COMMAND_EX(CG_ID_VIEW_MAINTOOLBAR, OnBarCheck)
	ON_UPDATE_COMMAND_UI(CG_ID_VIEW_MAINTOOLBAR, OnUpdateControlBarMenu)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_HELP_HOME, OnHelpHome)
	ON_COMMAND(ID_VIEW_TOOLS_FRAME, OnViewToolsFrame)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLS_FRAME, OnUpdateViewToolsFrame)
	ON_COMMAND(ID_VIEW_TOOLS_GRID, OnViewToolsGrid)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLS_GRID, OnUpdateViewToolsGrid)
	ON_COMMAND(ID_VIEW_TOOLS_CURRENTMODE, OnViewToolsCurrentmode)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLS_CURRENTMODE, OnUpdateViewToolsCurrentmode)
	ON_COMMAND(ID_VIEW_TOOLS_CURRENTACTION, OnViewToolsCurrentaction)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLS_CURRENTACTION, OnUpdateViewToolsCurrentaction)
	ON_COMMAND(ID_VIEW_TOOLS_GROUPS, OnViewToolsGroups)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLS_GROUPS, OnUpdateViewToolsGroups)
	ON_COMMAND(ID_VIEW_PRIMATIVE, OnViewPrimative)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PRIMATIVE, OnUpdateViewPrimative)
	ON_COMMAND(ID_VIEW_PLAYER, OnViewPlayer)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PLAYER, OnUpdateViewPlayer)
	ON_COMMAND(ID_ESCAPEPRESSED, OnEscapepressed)
	ON_COMMAND(ID_2_COPYFRAME, On2Copyframe)
	ON_COMMAND(ID_2_DELETEFRAME, On2Deleteframe)
	ON_COMMAND(ID_2_PASTEFRAMEAFTER, On2Pasteframeafter)
	ON_COMMAND(ID_2_PASTEFRAMEBEFORE, On2Pasteframebefore)
	ON_UPDATE_COMMAND_UI(ID_2_PASTEFRAMEAFTER, OnUpdate2Pasteframeafter)
	ON_UPDATE_COMMAND_UI(ID_2_PASTEFRAMEBEFORE, OnUpdate2Pasteframebefore)
	ON_COMMAND(ID_FILE_SETGAME, OnFileSetgame)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
#ifdef _BFIX
	FILE *out=fopen("C:\\meddlelog.txt","at");
	if(out)
	{
		fprintf(out,"mainfrm ctor \n");	
		fclose(out);
	}
#endif
	m_bShowActionTool=1;
	m_bShowModeTool=1;

}

CMainFrame::~CMainFrame()
{
	// Tool Dialogs

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
#ifdef _BFIX
	FILE *out=fopen("C:\\meddlelog.txt","at");
	if(out)
	{
		fprintf(out,"mainfrm on create \n");	
		fclose(out);
	}
#endif
	//AfxMessageBox("Main Start OnCreate");

	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		// Remember to try this: SBARS_SIZEGRIP
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY | CBRS_FLOAT_MULTI);
	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar(&m_wndToolBar);

	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_BUTTON_ZOOM), TBBS_CHECKBOX);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_BUTTON_GRID), TBBS_CHECKBOX);

	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_OGV_VERTEX), TBBS_CHECKGROUP);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_OGV_TRI), TBBS_CHECKGROUP);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_OGV_GROUP), TBBS_CHECKGROUP);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_OGV_OBJECT), TBBS_CHECKGROUP);
	m_wndToolBar.GetToolBarCtrl().CheckButton(ID_OGV_VERTEX);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_XYZ_XLOCK), TBBS_CHECKBOX);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_XYZ_YLOCK), TBBS_CHECKBOX);
	m_wndToolBar.SetButtonStyle(m_wndToolBar.CommandToIndex(ID_XYZ_ZLOCK), TBBS_CHECKBOX);

	//AfxMessageBox("Main Finish OnCreate");
	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::ShowSplashScreen(this);

//	AfxMessageBox("!");
//	// Create Tool Dialogs
//	m_tRotate.CreateToolDlg(this, "Rotate"); 
//	m_tPrimative.CreateToolDlg(this, "Primative"); 
//	m_tScale.CreateToolDlg(this, "Scale"); 
//	m_tSelection.CreateToolDlg(this, "Selection"); 
//	m_tGrid.CreateToolDlg(this, "Grid"); 
	
//	m_tFrame.CreateToolDlg(this, "Frame"); 
//	m_tBones.CreateToolDlg(this, "Bones"); 
//	m_tAnimate.CreateToolDlg(this, "Animation"); 
//	m_tGroup.CreateToolDlg(this, "Group"); 
//	m_tVert.CreateToolDlg(this, "Vertex"); 
//	m_tTri.CreateToolDlg(this, "Triangle"); 
	//

	CRect rc1, rc2,rc3,rc4;
	GetWindowRect(&rc1);
	GetClientRect(&rc3);
	m_wndToolBar.GetWindowRect(&rc4);
	int x,y;
	x=rc1.Width()-rc3.Width();
	x=x;
	y=rc1.Height()-rc3.Height();
//	m_tFrame->GetWindowRect(&rc2);
//	m_tFrame->SetWindowPos(NULL,rc1.right-rc2.Width()-x,rc1.top+100,0,0,
//		SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);
	
//	m_tFrame->GetWindowRect(&rc2);
//	m_tGroup->SetWindowPos(NULL,rc1.right-rc2.Width()-x,rc2.bottom,0,0,
//		SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);

//	m_tFrame->ShowWindow(SW_SHOW);
//	m_tGroup->ShowWindow(SW_SHOW);

//	m_bShowActionTool=1;
//	m_bShowModeTool=1;

	// TODO: Add a menu item that will toggle the visibility of the
	// dialog bar named "AnimFramesBar":
	//   1. In ResourceView, open the menu resource that is used by
	//      the CMainFrame class
	//   2. Select the View submenu
	//   3. Double-click on the blank item at the bottom of the submenu
	//   4. Assign the new item an ID: CG_ID_VIEW_ANIMFRAMESBAR
	//   5. Assign the item a Caption: AnimFramesBar

	// TODO: Change the value of CG_ID_VIEW_ANIMFRAMESBAR to an appropriate value:
	//   1. Open the file resource.h
	// CG: The following block was inserted by the 'Dialog Bar' component
/*	{
		// Initialize dialog bar m_wndAnimFramesBar
		if (!m_wndAnimFramesBar.Create(this, CG_IDD_ANIMFRAMESBAR,
			CBRS_RIGHT | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_HIDE_INPLACE,
			CG_ID_VIEW_ANIMFRAMESBAR))
		{
			TRACE0("Failed to create dialog bar m_wndAnimFramesBar\n");
			return -1;		// fail to create
		}

		m_wndAnimFramesBar.EnableDocking(CBRS_ALIGN_RIGHT | CBRS_ALIGN_LEFT);
		EnableDocking(CBRS_ALIGN_ANY);
		DockControlBar(&m_wndAnimFramesBar);

	}

*/	// TODO: Add a menu item that will toggle the visibility of the
	// dialog bar named "MainToolBar":
	//   1. In ResourceView, open the menu resource that is used by
	//      the CMainFrame class
	//   2. Select the View submenu
	//   3. Double-click on the blank item at the bottom of the submenu
	//   4. Assign the new item an ID: CG_ID_VIEW_MAINTOOLBAR
	//   5. Assign the item a Caption: MainToolBar

	// TODO: Change the value of CG_ID_VIEW_MAINTOOLBAR to an appropriate value:
	//   1. Open the file resource.h
	// CG: The following block was inserted by the 'Dialog Bar' component
	{
		// Initialize dialog bar m_wndMainToolBar
		if (!m_wndMainToolBar.Create(this, CG_IDD_MAINTOOLBAR,
			CBRS_LEFT | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_HIDE_INPLACE,
			CG_ID_VIEW_MAINTOOLBAR))
		{
			TRACE0("Failed to create dialog bar m_wndMainToolBar\n");
			return -1;		// fail to create
		}

		m_wndMainToolBar.EnableDocking(CBRS_ALIGN_RIGHT | CBRS_ALIGN_LEFT);
		EnableDocking(CBRS_ALIGN_ANY);
		DockControlBar(&m_wndMainToolBar);

		m_MainToolBar1.Create(IDD_MAIN1,&m_wndMainToolBar);
		m_MainToolBar1.ShowWindow(SW_SHOW);

	}

	return 0;
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	//AfxMessageBox("Main Start PreCreateWindow");
	cs.style &= ~FWS_ADDTOTITLE;
	cs.style |= WS_MAXIMIZE;
	return CMDIFrameWnd::PreCreateWindow(cs);
	//AfxMessageBox("Main Finish PreCreateWindow");
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers



void CMainFrame::OnHelpHome() 
{
	ShellExecute(m_hWnd,"open","http://meddle.telefragged.com",NULL,NULL,SW_SHOWDEFAULT);
}


//void CMainFrame::OnViewToolsBones() 
//{
//	m_tBones->ShowWindow(SW_SHOW);
//}

//void CMainFrame::OnUpdateViewToolsBones(CCmdUI* pCmdUI) 
//{
//	pCmdUI->SetCheck(m_tBones->IsWindowVisible());
//}

void CMainFrame::OnViewToolsFrame() 
{
//	m_tFrame.ShowWindow(SW_SHOW);
}

void CMainFrame::OnUpdateViewToolsFrame(CCmdUI* pCmdUI) 
{
//	pCmdUI->SetCheck(m_tFrame.IsWindowVisible());
}

void CMainFrame::OnViewToolsGrid() 
{
//	m_tGrid.ShowWindow(SW_SHOW);
}

void CMainFrame::OnUpdateViewToolsGrid(CCmdUI* pCmdUI) 
{
//	pCmdUI->SetCheck(m_tGrid.IsWindowVisible());
}

void CMainFrame::OnViewToolsCurrentmode() 
{
	if(m_bShowModeTool) m_bShowModeTool=0;
	else m_bShowModeTool=1;
	
}

void CMainFrame::OnUpdateViewToolsCurrentmode(CCmdUI* pCmdUI) 
{
	//pCmdUI->SetCheck(m_bShowModeTool);
	
}

void CMainFrame::OnViewToolsCurrentaction() 
{
	if(m_bShowActionTool) m_bShowActionTool=0;
	else m_bShowActionTool=1;
}

void CMainFrame::OnUpdateViewToolsCurrentaction(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}

void CMainFrame::OnViewToolsGroups() 
{
//	m_tGroup.ShowWindow(SW_SHOW);
	
}

void CMainFrame::OnUpdateViewToolsGroups(CCmdUI* pCmdUI) 
{
//	pCmdUI->SetCheck(m_tGroup.IsWindowVisible());
	
}

void CMainFrame::ArrangeTools()
{


}

void CMainFrame::OnViewPrimative() 
{
//	m_tPrimative.ShowWindow(SW_SHOW);	
}

void CMainFrame::OnUpdateViewPrimative(CCmdUI* pCmdUI) 
{
//	pCmdUI->SetCheck(m_tPrimative.IsWindowVisible());
}


void CMainFrame::OnViewPlayer() 
{
//	m_tAnimate.ShowWindow(SW_SHOW);
//		CRect rc;
//		rc.left=0; rc.top=0;
//		rc.right=100;
//		rc.bottom=100;
//		m_wnd3D1.Create(NULL, 
//			"Animation View", 
//			WS_CHILD|WS_VISIBLE, 
//			rc, 
//			&m_wndAnimFramesBar, 
//			1);
	
}

void CMainFrame::OnUpdateViewPlayer(CCmdUI* pCmdUI) 
{
//	pCmdUI->SetCheck(m_tAnimate.IsWindowVisible());
}

void CMainFrame::OnEscapepressed() 
{
//	AfxMessageBox("LL");
	m_MainToolBar1.m_tAnimate.FullScreen(0);
}

void CMainFrame::RefreshToolBar()
{
	m_MainToolBar1.Refresh();
}

void CMainFrame::On2Copyframe() 
{
	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

//	CString str;
//	int hit=m_MainToolBar1.m_FrameLC.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED );
//	if(hit == -1) { return;}
//	str=m_MainToolBar1.m_FrameLC.GetItemText(hit , 0 );

	if(!pDoc->m_MedDLeObject.m_curFrame) return;
	theApp.m_BaseClipBoard = *pDoc->m_MedDLeObject.m_BaseFrame;  // for copy, etc
	theApp.m_ClipBoard=*pDoc->m_MedDLeObject.m_curFrame;  // for copy, etc
	theApp.ClipBoardStatus=2;	// 0=empty
							// 1=parts
							// 2=wholeframe
	AfxMessageBox("hi");


}

void CMainFrame::On2Deleteframe() 
{
	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;
	AfxMessageBox("yhi");

	CString str;
	int hit=m_MainToolBar1.m_FrameLC.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED );
	if(hit == -1) { return;}
	str=m_MainToolBar1.m_FrameLC.GetItemText(hit , 0 );

	if(!pDoc->m_MedDLeObject.m_curFrame) return;
	theApp.m_BaseClipBoard = *pDoc->m_MedDLeObject.m_BaseFrame;  // for copy, etc
	theApp.m_ClipBoard=*pDoc->m_MedDLeObject.m_curFrame;  // for copy, etc
	theApp.ClipBoardStatus=2;	// 0=empty

// fix animation
	int i,j,gt;
	int N=pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist.GetSize();

	for(i=N-1; i>=0; i--)
	{
		j=pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist[i];
		if(str.CompareNoCase(pDoc->m_MedDLeObject.m_Frames[j]->name.GetBuffer(0))==0)
		{
			pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist.RemoveAt(i);
			if(pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist.GetSize()>0)
			{
				gt=pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist[i];
			}
			else
				gt=-1;
			break;
		}
	}
	
	N=pDoc->m_MedDLeObject.m_Frames.GetSize();  // for copy, etc

	for(i=N-1; i>=0; i--)
	{
		if(pDoc->m_MedDLeObject.m_Frames[i]==pDoc->m_MedDLeObject.m_curFrame)
		{
			pDoc->m_MedDLeObject.m_Frames.RemoveAt(i);
			delete pDoc->m_MedDLeObject.m_curFrame;
			pDoc->m_MedDLeObject.m_curFrame=NULL;
			pDoc->m_MedDLeObject.m_curFrameN=-1;
			if(gt>=0)
			{
				pDoc->m_MedDLeObject.m_curFrame=pDoc->m_MedDLeObject.m_Frames[gt];
			}
		}
	}

	// rename frames
	N=pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist.GetSize();

	for(i=0; i<N; i++)
	{
		j=pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->framelist[i];
		str.Format("%s%d",pDoc->m_MedDLeObject.m_Anims[pDoc->m_MedDLeObject.m_curAnimN]->name.GetBuffer(0),i+1);
		pDoc->m_MedDLeObject.m_Frames[j]->name=str;
	}

	m_MainToolBar1.Refresh();
}

void CMainFrame::On2Pasteframeafter() 
{
	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

	CString str;
	int hit=m_MainToolBar1.m_FrameLC.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED );
	if(hit == -1) { return;}
	str=m_MainToolBar1.m_FrameLC.GetItemText(hit , 0 );
	
	
	m_MainToolBar1.Refresh();
}

void CMainFrame::On2Pasteframebefore() 
{
	CMedDLeDoc *pDoc=theApp.m_pActiveDoc;

	CString str;
	int hit=m_MainToolBar1.m_FrameLC.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED );
	if(hit == -1) { return;}
	str=m_MainToolBar1.m_FrameLC.GetItemText(hit , 0 );
	
	m_MainToolBar1.Refresh();
}

void CMainFrame::OnUpdate2Pasteframeafter(CCmdUI* pCmdUI) 
{
	if(theApp.ClipBoardStatus==2) pCmdUI->Enable(TRUE);
	else  pCmdUI->Enable(FALSE);

}

void CMainFrame::OnUpdate2Pasteframebefore(CCmdUI* pCmdUI) 
{
	if(theApp.ClipBoardStatus==2) pCmdUI->Enable(TRUE);
	else  pCmdUI->Enable(FALSE);
}

#include "GameDlg.h"
void CMainFrame::OnFileSetgame() 
{
	CGameDlg dlg;
	dlg.DoModal();
}
